Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/HeuristicLab.Networks.IntegratedOptimization.TravelingThief-3.3.csproj
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/HeuristicLab.Networks.IntegratedOptimization.TravelingThief-3.3.csproj	(revision 14632)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/HeuristicLab.Networks.IntegratedOptimization.TravelingThief-3.3.csproj	(revision 14649)
@@ -84,4 +84,9 @@
     <Reference Include="HeuristicLab.Algorithms.ParameterlessPopulationPyramid-3.3">
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Algorithms.ParameterlessPopulationPyramid-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Analysis-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork1.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork1.cs	(revision 14632)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork1.cs	(revision 14649)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Linq;
 using HeuristicLab.Algorithms.CMAEvolutionStrategy;
 using HeuristicLab.Algorithms.LocalSearch;
@@ -45,4 +46,6 @@
       var cmaes = new CMAEvolutionStrategy();
       cmaes.Problem = new MaximizationVariegationProblem<RealVectorEncoding>();
+      var cmaAnalyzer = cmaes.Analyzer.Operators.OfType<CMAAnalyzer>().Single();
+      cmaes.Analyzer.Operators.SetItemCheckedState(cmaAnalyzer, true);
       cmaes.MaximumGenerations = 80;
       MetaSolver.Algorithm = cmaes;
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork2.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork2.cs	(revision 14632)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork2.cs	(revision 14649)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Linq;
 using HeuristicLab.Algorithms.CMAEvolutionStrategy;
 using HeuristicLab.Algorithms.LocalSearch;
@@ -45,4 +46,6 @@
       var cmaes = new CMAEvolutionStrategy();
       cmaes.Problem = new MaximizationVariegationProblem<RealVectorEncoding>();
+      var cmaAnalyzer = cmaes.Analyzer.Operators.OfType<CMAAnalyzer>().Single();
+      cmaes.Analyzer.Operators.SetItemCheckedState(cmaAnalyzer, true);
       cmaes.MaximumGenerations = 80;
       MetaSolver.Algorithm = cmaes;
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork3.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork3.cs	(revision 14632)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork3.cs	(revision 14649)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Linq;
 using HeuristicLab.Algorithms.CMAEvolutionStrategy;
 using HeuristicLab.Algorithms.LocalSearch;
@@ -45,4 +46,6 @@
       var cmaes = new CMAEvolutionStrategy();
       cmaes.Problem = new MaximizationVariegationProblem<RealVectorEncoding>();
+      var cmaAnalyzer = cmaes.Analyzer.Operators.OfType<CMAAnalyzer>().Single();
+      cmaes.Analyzer.Operators.SetItemCheckedState(cmaAnalyzer, true);
       cmaes.MaximumGenerations = 80;
       MetaSolver.Algorithm = cmaes;