Index: /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj
===================================================================
--- /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj	(revision 14657)
+++ /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj	(revision 14658)
@@ -170,4 +170,7 @@
     <Compile Include="Statistics\PairwiseTest.cs" />
     <Compile Include="Statistics\SampleSizeDetermination.cs" />
+    <Compile Include="Tracking\DoubleArraySnapshotCreaterAnalyzer.cs" />
+    <Compile Include="Tracking\IntArraySnapshotCreaterAnalyzer.cs" />
+    <Compile Include="Tracking\SnapshotCreaterAnalyzer.cs" />
     <Compile Include="ValueAnalysis\SingleValueAnalyzer.cs" />
     <Compile Include="ValueAnalysis\MinAverageMaxValueAnalyzer.cs" />
Index: /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/Tracking/DoubleArraySnapshotCreaterAnalyzer.cs
===================================================================
--- /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/Tracking/DoubleArraySnapshotCreaterAnalyzer.cs	(revision 14658)
+++ /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/Tracking/DoubleArraySnapshotCreaterAnalyzer.cs	(revision 14658)
@@ -0,0 +1,18 @@
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis {
+
+  [Item("DoubleArraySnapshotCreaterAnalyzer", "An operator that adds lightweight snapshots to all DoubleArrays`s for later analysis.")]
+  [StorableClass]
+  public sealed class DoubleArraySnapshotCreaterAnalyzer : SnapshotCreaterAnalyzer<double>, IAnalyzer {
+    [StorableConstructor]
+    private DoubleArraySnapshotCreaterAnalyzer(bool deserializing) : base(deserializing) { }
+    private DoubleArraySnapshotCreaterAnalyzer(DoubleArraySnapshotCreaterAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public DoubleArraySnapshotCreaterAnalyzer() { }
+    public override IDeepCloneable Clone(Cloner cloner) { return new DoubleArraySnapshotCreaterAnalyzer(this, cloner); }
+  }
+}
Index: /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/Tracking/IntArraySnapshotCreaterAnalyzer.cs
===================================================================
--- /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/Tracking/IntArraySnapshotCreaterAnalyzer.cs	(revision 14658)
+++ /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/Tracking/IntArraySnapshotCreaterAnalyzer.cs	(revision 14658)
@@ -0,0 +1,19 @@
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis {
+
+  [Item("IntArraySnapshotCreaterAnalyzer", "An operator that adds lightweight snapshots to all IntArray`s for later analysis.")]
+  [StorableClass]
+  public sealed class IntArraySnapshotCreaterAnalyzer : SnapshotCreaterAnalyzer<int>, IAnalyzer {
+
+    [StorableConstructor]
+    private IntArraySnapshotCreaterAnalyzer(bool deserializing) : base(deserializing) { }
+    private IntArraySnapshotCreaterAnalyzer(IntArraySnapshotCreaterAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public IntArraySnapshotCreaterAnalyzer() { }
+    public override IDeepCloneable Clone(Cloner cloner) { return new IntArraySnapshotCreaterAnalyzer(this, cloner); }
+  }
+}
Index: /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/Tracking/SnapshotCreaterAnalyzer.cs
===================================================================
--- /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/Tracking/SnapshotCreaterAnalyzer.cs	(revision 14658)
+++ /branches/PersistentDataStructures/HeuristicLab.Analysis/3.3/Tracking/SnapshotCreaterAnalyzer.cs	(revision 14658)
@@ -0,0 +1,69 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis {
+
+  [StorableClass]
+  public class SnapshotCreaterAnalyzer<T> : InstrumentedOperator, IAnalyzer where T : struct {
+
+    #region Parameter properties
+    public ScopeTreeLookupParameter<ValueTypeArray<T>> ArrayParameter {
+      get { return (ScopeTreeLookupParameter<ValueTypeArray<T>>)Parameters["Array"]; }
+    }
+    #endregion
+
+    #region Properties
+    public bool EnabledByDefault {
+      get { return true; }
+    }
+    #endregion
+
+    #region Storage & Cloning
+    [StorableConstructor]
+    protected SnapshotCreaterAnalyzer(bool deserializing) : base(deserializing) { }
+    protected SnapshotCreaterAnalyzer(SnapshotCreaterAnalyzer<T> original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SnapshotCreaterAnalyzer<T>(this, cloner);
+    }
+    #endregion
+
+    public SnapshotCreaterAnalyzer() {
+      Parameters.Add(new ScopeTreeLookupParameter<ValueTypeArray<T>>("Array", "The array of values that should get a new snapshot."));
+      ArrayParameter.Hidden = false;
+    }
+
+    public override IOperation InstrumentedApply() {
+      var arrays = ArrayParameter.ActualValue;
+      foreach (var a in arrays) {
+        a.CreateSnapshot();
+      }
+      return base.InstrumentedApply();
+    }
+  }
+}
Index: /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/HeuristicLab.Encodings.PermutationEncoding.Views-3.3.csproj
===================================================================
--- /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/HeuristicLab.Encodings.PermutationEncoding.Views-3.3.csproj	(revision 14657)
+++ /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/HeuristicLab.Encodings.PermutationEncoding.Views-3.3.csproj	(revision 14658)
@@ -122,4 +122,10 @@
       <DependentUpon>PermutationTypeView.cs</DependentUpon>
     </Compile>
+    <Compile Include="PermutationHistoryView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="PermutationHistoryView.Designer.cs">
+      <DependentUpon>PermutationHistoryView.cs</DependentUpon>
+    </Compile>
     <Compile Include="PermutationView.cs">
       <SubType>UserControl</SubType>
@@ -224,4 +230,9 @@
       <Install>true</Install>
     </BootstrapperPackage>
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="PermutationHistoryView.resx">
+      <DependentUpon>PermutationHistoryView.cs</DependentUpon>
+    </EmbeddedResource>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/PermutationHistoryView.Designer.cs
===================================================================
--- /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/PermutationHistoryView.Designer.cs	(revision 14658)
+++ /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/PermutationHistoryView.Designer.cs	(revision 14658)
@@ -0,0 +1,174 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Encodings.PermutationEncoding.Views {
+
+  partial class PermutationHistoryView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea1 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
+      System.Windows.Forms.DataVisualization.Charting.Legend legend1 = new System.Windows.Forms.DataVisualization.Charting.Legend();
+      this.tabControl = new System.Windows.Forms.TabControl();
+      this.movieTabPage = new System.Windows.Forms.TabPage();
+      this.trackBar = new System.Windows.Forms.TrackBar();
+      this.graphTabPage = new System.Windows.Forms.TabPage();
+      this.permutationView = new HeuristicLab.Encodings.PermutationEncoding.Views.PermutationView();
+      this.chart1 = new System.Windows.Forms.DataVisualization.Charting.Chart();
+      this.progressBar1 = new System.Windows.Forms.ProgressBar();
+      this.tabControl.SuspendLayout();
+      this.movieTabPage.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.trackBar)).BeginInit();
+      this.graphTabPage.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.chart1)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // tabControl
+      // 
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.movieTabPage);
+      this.tabControl.Controls.Add(this.graphTabPage);
+      this.tabControl.Location = new System.Drawing.Point(3, 3);
+      this.tabControl.Name = "tabControl";
+      this.tabControl.SelectedIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(387, 383);
+      this.tabControl.TabIndex = 4;
+      this.tabControl.Selected += new System.Windows.Forms.TabControlEventHandler(this.tabControl_Selected);
+      // 
+      // movieTabPage
+      // 
+      this.movieTabPage.Controls.Add(this.permutationView);
+      this.movieTabPage.Controls.Add(this.trackBar);
+      this.movieTabPage.Location = new System.Drawing.Point(4, 22);
+      this.movieTabPage.Name = "movieTabPage";
+      this.movieTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.movieTabPage.Size = new System.Drawing.Size(379, 357);
+      this.movieTabPage.TabIndex = 0;
+      this.movieTabPage.Text = "Movie";
+      this.movieTabPage.UseVisualStyleBackColor = true;
+      // 
+      // trackBar
+      // 
+      this.trackBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.trackBar.Location = new System.Drawing.Point(6, 306);
+      this.trackBar.Name = "trackBar";
+      this.trackBar.Size = new System.Drawing.Size(367, 45);
+      this.trackBar.TabIndex = 0;
+      this.trackBar.Scroll += new System.EventHandler(this.trackBar_Scroll);
+      // 
+      // graphTabPage
+      // 
+      this.graphTabPage.Controls.Add(this.progressBar1);
+      this.graphTabPage.Controls.Add(this.chart1);
+      this.graphTabPage.Location = new System.Drawing.Point(4, 22);
+      this.graphTabPage.Name = "graphTabPage";
+      this.graphTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.graphTabPage.Size = new System.Drawing.Size(379, 357);
+      this.graphTabPage.TabIndex = 1;
+      this.graphTabPage.Text = "Graph";
+      this.graphTabPage.UseVisualStyleBackColor = true;
+      // 
+      // permutationView
+      // 
+      this.permutationView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.permutationView.Caption = "Permutation View";
+      this.permutationView.Content = null;
+      this.permutationView.Location = new System.Drawing.Point(6, 6);
+      this.permutationView.Name = "permutationView";
+      this.permutationView.ReadOnly = false;
+      this.permutationView.Size = new System.Drawing.Size(367, 294);
+      this.permutationView.TabIndex = 1;
+      // 
+      // chart1
+      // 
+      this.chart1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      chartArea1.Name = "ChartArea1";
+      this.chart1.ChartAreas.Add(chartArea1);
+      legend1.Name = "Legend1";
+      this.chart1.Legends.Add(legend1);
+      this.chart1.Location = new System.Drawing.Point(6, 6);
+      this.chart1.Name = "chart1";
+      this.chart1.Size = new System.Drawing.Size(367, 316);
+      this.chart1.TabIndex = 0;
+      this.chart1.Text = "chart";
+      // 
+      // progressBar1
+      // 
+      this.progressBar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.progressBar1.Location = new System.Drawing.Point(7, 328);
+      this.progressBar1.Name = "progressBar1";
+      this.progressBar1.Size = new System.Drawing.Size(366, 23);
+      this.progressBar1.TabIndex = 1;
+      // 
+      // PermutationHistoryView
+      // 
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.tabControl);
+      this.Name = "PermutationHistoryView";
+      this.Size = new System.Drawing.Size(393, 389);
+      this.tabControl.ResumeLayout(false);
+      this.movieTabPage.ResumeLayout(false);
+      this.movieTabPage.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.trackBar)).EndInit();
+      this.graphTabPage.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.chart1)).EndInit();
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+    private System.Windows.Forms.TabControl tabControl;
+    private System.Windows.Forms.TabPage movieTabPage;
+    private System.Windows.Forms.TabPage graphTabPage;
+    private System.Windows.Forms.TrackBar trackBar;
+    private PermutationView permutationView;
+    private System.Windows.Forms.DataVisualization.Charting.Chart chart1;
+    private System.Windows.Forms.ProgressBar progressBar1;
+  }
+}
Index: /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/PermutationHistoryView.cs
===================================================================
--- /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/PermutationHistoryView.cs	(revision 14658)
+++ /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/PermutationHistoryView.cs	(revision 14658)
@@ -0,0 +1,184 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.IO.Pipes;
+using System.Linq;
+using System.Windows.Forms;
+using System.Windows.Forms.DataVisualization.Charting;
+using HeuristicLab.Data;
+using HeuristicLab.Data.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Encodings.PermutationEncoding.Views {
+
+  [View("Permutation History View")]
+  [Content(typeof(Permutation), IsDefaultView = false)]
+  public partial class PermutationHistoryView : AsynchronousContentView {
+
+    public new Permutation Content {
+      get { return (Permutation)base.Content; }
+      set { base.Content = value; }
+    }
+
+    private List<Permutation> contentHistory;
+
+    public PermutationHistoryView() {
+      InitializeComponent();
+    }
+
+    #region Register Content Events
+    protected override void DeregisterContentEvents() {
+      base.DeregisterContentEvents();
+    }
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+    }
+    #endregion
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        contentHistory = null;
+        trackBar.Maximum = 0;
+        permutationView.Content = null;
+      } else {
+        contentHistory =
+          Content.GetHistory().Select(a => new Permutation(Content.PermutationType, (IntArray) a)).Reverse().ToList();
+        trackBar.Maximum = contentHistory.Count-1;
+        trackBar.Value = trackBar.Maximum;
+        permutationView.Content = Content;
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+    }
+
+    #region Event Handlers
+
+    #endregion
+
+    private void trackBar_Scroll(object sender, System.EventArgs e) {
+      permutationView.Content = contentHistory[trackBar.Value];
+    }
+
+    private class Edge {
+      public int Start, End, Offset;
+
+      public Edge(int start, int end, int offset) {
+        Start = start;
+        End = end;
+        Offset = offset;
+      }
+    }
+
+    private void tabControl_Selected(object sender, TabControlEventArgs e) {
+      if (e.TabPage == graphTabPage) {
+        if (chart1.Series.Count == 0) {
+          progressBar1.Maximum = 100;
+          progressBar1.Value = 0;
+          var worker = new BackgroundWorker();
+          worker.WorkerReportsProgress = true;
+          worker.WorkerSupportsCancellation = true;
+          worker.ProgressChanged += (s, args) => {
+            if (args.ProgressPercentage >= 0) {
+              progressBar1.Style = ProgressBarStyle.Continuous;
+              progressBar1.Value = Math.Min(args.ProgressPercentage, progressBar1.Maximum);
+            } else {
+              progressBar1.Style = ProgressBarStyle.Marquee;
+            }
+          };
+          var edgePositions = Enumerable.Range(0, 8).Select(i => new List<int>()).ToList();
+          worker.DoWork += (s, args) => {
+            var edgeCount = new Dictionary<Tuple<int, int>, int>();
+            var progress = 0;
+            foreach (var permutation in contentHistory) {
+              int last = permutation[0];
+              worker.ReportProgress(100 * progress++ / contentHistory.Count);
+              if (worker.CancellationPending) {
+                args.Cancel = true;
+                return;
+              }
+              for (int i = 1; i < permutation.Length; i++) {
+                var key = Tuple.Create(last, permutation[i]);
+                int count = 0;
+                edgeCount.TryGetValue(key, out count);
+                edgeCount[key] = count + 1;
+                last = permutation[i];
+              }
+            }
+            worker.ReportProgress(-1);
+            var topEdges = edgeCount
+              .OrderByDescending(kvp => kvp.Value)
+              .Take(edgePositions.Count)
+              .Select((kvp, i) => new {i, kvp.Key, kvp.Value})
+              .ToDictionary(x => x.Key, x => new {count = x.Value, index = x.i});
+            worker.ReportProgress(0);
+            int n = 0;
+            foreach (var permutation in contentHistory) {
+              n++;
+              int last = permutation[0];
+              worker.ReportProgress(100 * progress++ / contentHistory.Count);
+              if (worker.CancellationPending) {
+                args.Cancel = true;
+                return;
+              }
+              for (int i = 1; i < permutation.Length; i++) {
+                var key = Tuple.Create(last, permutation[i]);
+                if (topEdges.ContainsKey(key)) {
+                  edgePositions[topEdges[key].index].Add(i);
+                  int count = 0;
+                  edgeCount.TryGetValue(key, out count);
+                  edgeCount[key] = count + 1;
+                }
+                last = permutation[i];
+              }
+              foreach (List<int> list in edgePositions) {
+                while (list.Count < n) {
+                  if (list.Count > 0)
+                    list.Add(list[list.Count-1]);
+                  else
+                    list.Add(0);
+                }
+              }
+            }
+          };
+          worker.RunWorkerCompleted += (s, args) => {
+            chart1.Series.Clear();
+            foreach (var list in edgePositions) {
+              var series = new Series();
+              series.ChartType = SeriesChartType.FastLine;
+              foreach (var n in list) {
+                series.Points.Add(n);
+              }
+              chart1.Series.Add(series);
+            }
+          };
+          worker.RunWorkerAsync();
+        }
+      }
+    }
+  }
+}
Index: /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/PermutationHistoryView.resx
===================================================================
--- /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/PermutationHistoryView.resx	(revision 14658)
+++ /branches/PersistentDataStructures/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/PermutationHistoryView.resx	(revision 14658)
@@ -0,0 +1,120 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>